package cn.net.cpzslibs.prot;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import cn.net.cpzslibs.prot.bean.req.Prot10016ProductBean;
import cn.net.cpzslibs.prot.bean.res.Prot10016ProductResultInfo;
import cn.net.cpzslibs.prot.bean.res.Prot10016ResultBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10016ProductList extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;

	private final short iTaskCode10016 = 10016;
	// private String jsonData;
	// private String sInspectorId;
	private Gson gson;
	private Prot10016ResultBean productResult;
	private List<Prot10016ProductResultInfo> products = new ArrayList<>();
	private boolean isEnd = false;//true：所有协议包已经请求完      false：服务器返回的数据还未接收完全

	public Prot10016ProductList() {
		// this.sInspectorId = sInspectorId;
		gson = new Gson();
	}

	public Prot10016ResultBean getProductResult() {
		return this.productResult;
	}

	public void dealProductList(SocketCreate create, Prot10016ProductBean productBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), productBean);
	}

	private void recProt(Socket socket, DataOutputStream dos, DataInputStream dis, Prot10016ProductBean productBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10016, "开始请求产品列表");
				sendProt(dos, productBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				while (!isEnd) {
					//服务器可能分多次包返回数据
					recLoginDis(dis);
				}
			}
		}
	}

	static int cTest = 0;

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10016, (cTest++) + "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10016, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			productResult = gson.fromJson(jsonData, Prot10016ResultBean.class);
			
			if (productResult.getProducts() != null) {
				products.addAll(productResult.getProducts());
			}
			if (productResult.getCurrPackCount() == 0) {
				//所有协议包已经请求完
				productResult.setProducts(products);
				isEnd = true;
			}
			if (productResult.getResult() == 1) {
				//请求时遇到错误信息
				isEnd = true;
			}
		} else {
			isEnd = true;
		}

		recCheckCode(dis);
		
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10016ProductBean productBean) throws IOException {
		String bodyContent = gson.toJson(productBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10016, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		// sendCheckCode(dos);
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

}
